﻿class NetConnectionAS2 extends NetConnection {
	private var __urlSuffix:String = null;
	private var __originalUrl:String = null;
	public var uri:String;
	// This function creates a service proxy object associated with this NetConnection.
	public function getService(serviceName, client) {
		var result = new NetServiceProxy(this, serviceName, client);
		//trace("NetConnection.getService " + result);
		return result;
	}
	// This function sets the credentials into a standard header which gets sent to the server
	// on all subsequent requests.
	public function setCredentials(userid, password) {
		this.addHeader("Credentials", false, {userid:userid, password:password});
	}
	// This function gets called whenever a RequestPersistentHeader header is received from the server.
	public function RequestPersistentHeader(info) {
		//trace("NetConnection_RequestPersistentHeader(" + objectToString(info) + ")");
		this.addHeader(info.name, info.mustUnderstand, info.data);
	}
	// This function gets called whenever a AppendToGatewayUrl header is received from the server.
	public function AppendToGatewayUrl(urlSuffix) {
		this.__urlSuffix = urlSuffix;
		if (this.__originalUrl == null) {
			this.__originalUrl = this.uri;
		}
		var u = this.__originalUrl+urlSuffix;
		this.connect(u);
	}
	// This function gets called whenever a ReplaceGatewayUrl header is received from the server.
	public function ReplaceGatewayUrl(newUrl) {
		this.connect(newUrl);
	}
	// This function creates a new netconnection, which is just like the old connection,
	// except it doesn't have the headers.
	public function clone() {
		var nc = new NetConnection();
		nc.connect(this.uri);
		return nc;
	}
}
