﻿class NetServiceProxy {
	public var nc:NetConnection = null;
	public var serviceName:String = null;
	public var client = null;
	function NetServiceProxy(nc, serviceName, client) {
		if (nc != null) {
			// the constructor was called from ActionScript code
			this.nc = nc;
			this.serviceName = serviceName;
			this.client = client;
		}
		// else - parameter is null, this probably means that 
		// this object has just been received as a typed object in an AMF message.
		// just leave the data alone. construction of this object
		// will be completed when _setParentService is called.
	}
	public function _setParentService(service) {
		this.nc = service.nc;
		this.client = service.client;
	}
	// This function gets called whenever somebody does "myService.methodName(parameters...)".
	// We construct and return the function "f", which knows how to call the correct server method. 
	public function __resolve(methodName) {
		var f = function () {
			// did the user give a default client when he created this NetServiceProxy?
			if (this.client != null) {
				// Yes. Let's create a responder object.
				arguments.unshift(new NetServiceProxyResponder(this, methodName));
			} else {
				if (typeof (arguments[0].onResult) != "function") {
					// NetServices.trace("NetServices", "warning", 3, "There is no defaultResponder, but no responder was given in call to "+methodName);
					arguments.unshift(new NetServiceProxyResponder(this, methodName));
				}
			}
			arguments.unshift(this.serviceName+"."+methodName);
			return this.nc.call.apply(this.nc, arguments);
		};
		return f;
	}
}
