﻿class NetServiceProxyResponder {
	private var service:Object = null;
	private var methodName:String = null;
	function NetServiceProxyResponder(svc, mName) {
		service = svc;
		methodName = mName;
	}

	// This function gets called whenever an onResult is received from the server
	// as a result of a call that is being handled by our responder object.
	public function onResult(result) {
		var client = this.service.client;
		// tell the result object what service it came from, if it wants to know.
		// (this call usually has no effect, except for NetServiceProxy and RecordSet).
		result._setParentService(this.service);
		var func = this.methodName+"_Result";
		if (typeof (client[func]) == "function") {
			// there is an "xxx_Result" method supplied - call it.
			client[func](result);
		} else if (typeof (client.onResult) == "function") {
			// there is an "onResult" method supplied - call it.
			client.onResult(result);
		} else {
			// nobody to call. Dump something to the output window.
		    //NetServices.trace("NetServices", "info", 1, func+" was received from server: "+result);
		}
	}
	// This function gets called whenever an onStatus is received from the server
	// as a result of a call that is being handled by our responder object.
	public function onStatus(result) {
		//trace("NetServiceProxyResponder.onStatus(" + objectToString(result) + ")");
		var client = this.service.client;
		var func = this.methodName+"_Status";
		if (typeof (client[func]) == "function") {
			// there is an "xxx_Status" method supplied - call it.
			client[func](result);
		} else if (typeof (client.onStatus) == "function") {
			// there is an "onStatus" method supplied - call it.
			client.onStatus(result);
		} else if (typeof (_root.onStatus) == "function") {
			// there is an "onStatus" method at the root level - call it.
			_root.onStatus(result);
		} else if (typeof (_global.System.onStatus) == "function") {
			// there is an "onStatus" method at the global level - call it.
			_global.System.onStatus(result);
		} else {
			// nobody to call. Dump something to the output window.
			//NetServices.trace("NetServices", "info", 2, func+" was received from server: <"+result.level+"> "+result.description);
		}
	}
}
