﻿//import mx.remoting.*;
class NetServices {
	private static var gatewayUrl:String = _global.gatewayUrl;
	private static var defaultGatewayUrl:String = null;
	public static function setDefaultGatewayUrl(url) {
		//trace("NetServices.setDefaultGatewayUrl " + url);
		NetServices.defaultGatewayUrl = url;
	}
	public static function setGatewayUrl(url) {
		//trace("NetServices.setGatewayUrl " + url);
		NetServices.gatewayUrl = url;
	}
	// createGatewayConnection creates a NetConnection and connects it to the
	// gateway. We choose an appropriate URL for the gateway.
	public static function createGatewayConnection(url) {
		if (url == undefined) {
			// Our first choice: the "gatewayURL" param that got passed to this .swf via the object/embed tag
			// The developer could also set "gatewayUrl" *before* including NetServices.as.
			url = NetServices.gatewayUrl;
			if (url == undefined) {
				// our second choice: the default url that the developer said to use
				url = NetServices.defaultGatewayUrl;
			}
		}
		// See if we were able to find a gateway url to use	
		if (url == undefined) {
			// no url. no good.
			NetServices.trace("NetServices", "warning", 4, "createGatewayConnection - gateway url is undefined");
			return null;
		}
		// We found a gateway URL. Create the NetConnection object and connect to the URL.
		var nc = new NetConnectionAS2();
		nc.connect(url);
		Object.registerClass("RecordSet", RecordSet);
		//trace("NetServices.createGatewayConnection " + nc);
		return nc;
	}
	// getHostUrl returns the hostname (and port) of the URL that contains the current .swf file.
	// there is no trailing "/". returns null if the url is not http://something.
	// example: if the swf url is http://my.foo.com:1234/some/thing/my.swf, this
	// function will return "http://my.foo.com:1234".
	public static function getHostUrl() {
		if (!NetServices.isHttpUrl(_root._url)) {
			// this url doesn't start with "http://", I don't know what to do with it.
			return null;
		}
		var firstSlashPos = _root._url.indexOf("/", 8);
		if (firstSlashPos<0) {
			// hmmm...
			return null;
		}
		return _root._url.substring(0, firstSlashPos);
	}
	public static function isHttpUrl(url) {
		// return url.startsWith("http://") || url.startsWith("https://");
		return ((url.indexOf("http://") == 0) || (url.indexOf("https://") == 0));
	}
	// a function for reporting errors
	public static function trace(who, severity, number, message) {
		var fullMessage = who+" "+severity+" "+number+": "+message;
		trace(fullMessage);
		//NetDebug.traceNetServices(who, severity, number, message);
	}
	// a function for telling the version number of NetServices and RecordSet
	public static function getVersion() {
		return 1;
		// this value is also in the RecordSet constructor.
	}
}
