﻿class RsDataFetcher {
private var mRecordSet = null;
private var mIncrement = null;
private var mNextRecord = null;
private var mEnabled = null;
private var mHighestRequested = null;

 function RsDataFetcher (recordSet, increment)
{
	//trace("RsDataFetcher.constructor(" + recordSet + ", " + increment + ")");
	this.mRecordSet = recordSet;
	this.mRecordSet.addView(this);
	this.mIncrement = increment;
	this.mNextRecord = 0;
	this.mEnabled = true;

	this.doNext();
}

public function disable ()
{
	this.mEnabled = false;
	this.mRecordSet.removeView(this); // !!@ not implemented
	//trace("RsDataFetcher disabled");
}

public function doNext ()
{
	//trace("RsDataFetcher.doNext()");
	if (!this.mEnabled)
	{
		return;
	}

	while (true)
	{
		if (this.mNextRecord >= this.mRecordSet.getLength())
		{
			//trace("RsDataFetcher done");
			return;
		}

		this.mHighestRequested = this.mRecordSet.requestRecordRange(this.mNextRecord, this.mNextRecord + this.mIncrement - 1);
		this.mNextRecord += this.mIncrement;

		if (this.mHighestRequested > 0)
		{
			//trace("RsDataFetcher request underway " + this.mHighestRequested);
			return;
		}
		//trace("RsDataFetcher.trying again");
	}
}		

public function modelChanged (eventObj)
{
	//trace("RsDataFetcher.modelChanged(" + eventObj.serial + " " + eventObj.event + "," + eventObj.firstRow + "," + eventObj.lastRow + "..." + this.mHighestRequested + ")");
	if ((eventObj.event == "updateRows") && 
	    (eventObj.firstRow <= this.mHighestRequested) && 
	    (eventObj.lastRow >= this.mHighestRequested))
	{
		//trace("RsDataFetcher.request done. doing next");
		this.doNext();
	}
	if (eventObj.event == "allRows")
	{
		//trace("RsDataFetcher.allrows received");
		this.disable();
	}
};
}