﻿class RsDataProviderClass {
	private var items:Array = null;
	private var uniqueID:Number = null;
	private var views:Array = null;
	function RsDataProviderClass() {
		this.init();
	}
	public function init() {
		this.items = new Array();
		this.uniqueID = 0;
		this.views = new Array();
	}
	public function addView(viewRef) {
		//removeView needed?
		this.views.push(viewRef);
		var eventObj = {event:"updateAll"};
		viewRef.modelChanged(eventObj);
	}
	public function addItemAt(index, value) {
		if (!this.checkLocal()) {
			return;
		}
		if (index<0) {
			return;
		}
		if (index<this.getLength()) {
			this.items.splice(index, 0, "tmp");
		}
		this.items[index] = new Object();
		if (typeof (value) == "object") {
			this.items[index] = value;
			//	} else {
			//		this.items[index].label = value;
		}
		this.items[index].__ID__ = this.uniqueID++;
		var eventObj = {event:"addRows", firstRow:index, lastRow:index};
		this.updateViews(eventObj);
	}
	public function addItem(value) {
		if (!this.checkLocal()) {
			return;
		}
		this.addItemAt(this.getLength(), value);
	}
	public function removeItemAt(index) {
		if (!this.checkLocal()) {
			return;
		}
		if (index<0 || index>=this.getLength()) {
			return;
		}
		var tmpItm = this.items[index];
		this.items.splice(index, 1);
		var eventObj = {event:"deleteRows", firstRow:index, lastRow:index};
		this.updateViews(eventObj);
		return tmpItm;
	}
	public function removeAll() {
		if (!this.checkLocal()) {
			return;
		}
		this.items = new Array();
		this.updateViews({event:"deleteRows", firstRow:0, lastRow:this.getLength()-1});
	}
	public function replaceItemAt(index, itemObj) {
		if (!this.checkLocal()) {
			return;
		}
		if (index<0 || index>=this.getLength()) {
			return;
		}
		var tmpID = this.getItemID(index);
		this.items[index] = itemObj;
		this.items[index].__ID__ = tmpID;
		this.updateViews({event:"updateRows", firstRow:index, lastRow:index});
	}
	public function getLength() {
		return this.items.length;
	}
	public function getItemAt(index) {
		return this.items[index];
	}
	public function getItemID(index) {
		return this.items[index].__ID__;
	}
	public function sortItemsBy(fieldName, order) {
		if (!this.checkLocal()) {
			return;
		}
		this.items.sortOn(fieldName);
		if (order == "DESC") {
			this.items.reverse();
		}
		this.updateViews({event:"sort", fieldName:fieldName, order:order});
	}
	// ::: PRIVATE METHODS
	private function updateViews(eventObj) {
		//eventObj.serial = "$$" + this.mSerial++;
		//trace("updating views..." + eventObj.serial + " " + eventObj.event);
		var vlen = this.views.length;
		for (var i = 0; i<vlen; i++) {
			this.views[i].modelChanged(eventObj);
		}
	}
	private function checkLocal() {
		return true;
	}
}
